Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 7990)
@@ -8,4 +8,5 @@
    !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!            3.6  ! 2013-04  (G. Madec, F. Roquet) zrau compute locally using interpolation of alpha & beta
+   !!            4.0  !  2017-04  (G. Madec)  remove CPP ddm key & avm at t-point only 
    !!----------------------------------------------------------------------
 
@@ -22,5 +23,4 @@
    USE prtctl         ! Print control
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE timing         ! Timing
 
@@ -63,5 +63,5 @@
       !!      avt = avt + zavft + zavdt
       !!      avs = avs + zavfs + zavds
-      !!      avmu, avmv are required to remain at least above avt and avs.
+      !!      avm is required to remain at least above avt and avs.
       !!      
       !! ** Action  :   avt, avs : updated vertical eddy diffusivity coef. for T & S
@@ -77,10 +77,8 @@
       REAL(wp) ::   zavft, zavfs    !   -      -
       REAL(wp) ::   zavdt, zavds    !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3
+      REAL(wp), DIMENSION(jpi,jpj) ::   zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('zdf_ddm')
-      !
-      CALL wrk_alloc( jpi,jpj, zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3 )
+      IF( nn_timing == 1 )   CALL timing_start('zdf_ddm')
       !
       !                                                ! ===============
@@ -89,7 +87,12 @@
          ! Define the mask 
          ! ---------------
+!!gm  WORK to be done:   change the code from vector optimisation to scalar one.
+!!gm                     ==>>>  test in the loop instead of use of mask arrays
+!!gm                            and many acces in memory
+         
          DO jj = 1, jpj                                ! R=zrau = (alpha / beta) (dk[t] / dk[s])
             DO ji = 1, jpi
                zrw =   ( gdepw_n(ji,jj,jk  ) - gdept_n(ji,jj,jk) )   &
+!!gm please, use e3w_n below 
                   &  / ( gdept_n(ji,jj,jk-1) - gdept_n(ji,jj,jk) ) 
                !
@@ -156,36 +159,11 @@
             END DO
          END DO
-
-
-         ! Increase avmu, avmv if necessary
-         ! --------------------------------
-!!gm to be changed following the definition of avm.
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk),    &
-                  &                  avt(ji,jj,jk), avt(ji+1,jj,jk),   &
-                  &                  avs(ji,jj,jk), avs(ji+1,jj,jk) )  * wumask(ji,jj,jk)
-               avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk),    &
-                  &                  avt(ji,jj,jk), avt(ji,jj+1,jk),   &
-                  &                  avs(ji,jj,jk), avs(ji,jj+1,jk) )  * wvmask(ji,jj,jk)
-            END DO
-         END DO
          !                                                ! ===============
       END DO                                              !   End of slab
       !                                                   ! ===============
       !
-      CALL lbc_lnk( avt , 'W', 1._wp )     ! Lateral boundary conditions   (unchanged sign)
-      CALL lbc_lnk( avs , 'W', 1._wp )
-      CALL lbc_lnk( avm , 'W', 1._wp )
-      CALL lbc_lnk( avmu, 'U', 1._wp ) 
-      CALL lbc_lnk( avmv, 'V', 1._wp )
-
       IF(ln_ctl) THEN
          CALL prt_ctl(tab3d_1=avt , clinfo1=' ddm  - t: ', tab3d_2=avs , clinfo2=' s: ', ovlap=1, kdim=jpk)
-         CALL prt_ctl(tab3d_1=avmu, clinfo1=' ddm  - u: ', mask1=umask, &
-            &         tab3d_2=avmv, clinfo2=       ' v: ', mask2=vmask, ovlap=1, kdim=jpk)
       ENDIF
-      !
-      CALL wrk_dealloc( jpi,jpj, zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3 )
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_ddm')
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfevd.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfevd.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfevd.F90	(revision 7990)
@@ -8,4 +8,5 @@
    !!   NEMO     1.0  !  2002-06  (G. Madec)  F90: Free form and module
    !!            3.2  !  2009-03  (M. Leclair, G. Madec, R. Benshila) test on both before & after
+   !!            4.0  !  2017-04  (G. Madec)  evd applied on avm (at t-point) 
    !!----------------------------------------------------------------------
 
@@ -23,5 +24,4 @@
    USE iom             ! for iom_put
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! work arrays
    USE timing          ! Timing
 
@@ -45,16 +45,18 @@
       !!      sivity coefficients when a static instability is encountered.
       !!
-      !! ** Method  :   avt, avm, and the 4 neighbouring avmu, avmv coefficients
-      !!      are set to avevd (namelist parameter) if the water column is 
-      !!      statically unstable (i.e. if rn2 < -1.e-12 )
+      !! ** Method  :   tracer (and momentum if nn_evdm=1) vertical mixing 
+      !!              coefficients are set to rn_evd (namelist parameter) 
+      !!              if the water column is statically unstable.
+      !!                The test of static instability is performed using
+      !!              Brunt-Vaisala frequency (rn2 < -1.e-12) of to successive
+      !!              time-step (Leap-Frog environnement): before and
+      !!              now time-step.
       !!
-      !! ** Action  :   avt, avm, avmu, avmv updted in static instability cases
-      !!
-      !! References :   Lazar, A., these de l'universite Paris VI, France, 1997
+      !! ** Action  :   avt, avm   enhanced where static instability occurs
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step indexocean time step
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step indexocean time step
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zavt_evd, zavm_evd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zavt_evd, zavm_evd
       !!----------------------------------------------------------------------
       !
@@ -68,5 +70,4 @@
       ENDIF
       !
-      CALL wrk_alloc( jpi,jpj,jpk,   zavt_evd, zavm_evd ) 
       !
       zavt_evd(:,:,:) = avt(:,:,:)           ! set avt prior to evd application
@@ -74,35 +75,39 @@
       SELECT CASE ( nn_evdm )
       !
-      CASE ( 1 )           ! enhance vertical eddy viscosity and diffusivity (if rn2<-1.e-12)
+      CASE ( 1 )           !==  enhance tracer & momentum Kz  ==!   (if rn2<-1.e-12)
          !
          zavm_evd(:,:,:) = avm(:,:,:)           ! set avm prior to evd application
          !
+!! change last digits results
+!         WHERE( MAX( rn2(2:jpi,2:jpj,2:jpkm1), rn2b(2:jpi,2:jpj,2:jpkm1) )  <= -1.e-12 ) THEN
+!            avt(2:jpi,2:jpj,2:jpkm1) = rn_evd * wmask(2:jpi,2:jpj,2:jpkm1)
+!            avm(2:jpi,2:jpj,2:jpkm1) = rn_evd * wmask(2:jpi,2:jpj,2:jpkm1)
+!         END WHERE
+         !
          DO jk = 1, jpkm1 
-            DO jj = 2, jpj             ! no vector opt.
-               DO ji = 2, jpi
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
                   IF(  MIN( rn2(ji,jj,jk), rn2b(ji,jj,jk) ) <= -1.e-12 ) THEN
-                     avt (ji  ,jj  ,jk) = rn_evd * tmask(ji  ,jj  ,jk)
-                     avm (ji  ,jj  ,jk) = rn_evd * tmask(ji  ,jj  ,jk)
-                     avmu(ji  ,jj  ,jk) = rn_evd * umask(ji  ,jj  ,jk)
-                     avmu(ji-1,jj  ,jk) = rn_evd * umask(ji-1,jj  ,jk)
-                     avmv(ji  ,jj  ,jk) = rn_evd * vmask(ji  ,jj  ,jk)
-                     avmv(ji  ,jj-1,jk) = rn_evd * vmask(ji  ,jj-1,jk)
+                     avt(ji,jj,jk) = rn_evd * wmask(ji,jj,jk)
+                     avm(ji,jj,jk) = rn_evd * wmask(ji,jj,jk)
                   ENDIF
                END DO
             END DO
          END DO 
-         CALL lbc_lnk( avt , 'W', 1. )   ;   CALL lbc_lnk( avm , 'W', 1. )   ! Lateral boundary conditions
-         CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )
          !
          zavm_evd(:,:,:) = avm(:,:,:) - zavm_evd(:,:,:)   ! change in avm due to evd
          CALL iom_put( "avm_evd", zavm_evd )              ! output this change
          !
-      CASE DEFAULT         ! enhance vertical eddy diffusivity only (if rn2<-1.e-12) 
+      CASE DEFAULT         !==  enhance tracer Kz  ==!   (if rn2<-1.e-12) 
+!! change last digits results
+!         WHERE( MAX( rn2(2:jpi,2:jpj,2:jpkm1), rn2b(2:jpi,2:jpj,2:jpkm1) )  <= -1.e-12 )
+!            avt(2:jpi,2:jpj,2:jpkm1) = rn_evd * wmask(2:jpi,2:jpj,2:jpkm1)
+!         END WHERE
+
          DO jk = 1, jpkm1
-!!!         WHERE( rn2(:,:,jk) <= -1.e-12 ) avt(:,:,jk) = tmask(:,:,jk) * avevd   ! agissant sur T SEUL! 
-            DO jj = 1, jpj             ! loop over the whole domain (no lbc_lnk call)
-               DO ji = 1, jpi
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
                   IF(  MIN( rn2(ji,jj,jk), rn2b(ji,jj,jk) ) <= -1.e-12 )   &
-                     avt(ji,jj,jk) = rn_evd * tmask(ji,jj,jk)
+                     avt(ji,jj,jk) = rn_evd * wmask(ji,jj,jk)
                END DO
             END DO
@@ -110,10 +115,8 @@
          !
       END SELECT 
-
+      !
       zavt_evd(:,:,:) = avt(:,:,:) - zavt_evd(:,:,:)   ! change in avt due to evd
       CALL iom_put( "avt_evd", zavt_evd )              ! output this change
       IF( l_trdtra ) CALL trd_tra( kt, 'TRA', jp_tem, jptra_evd, zavt_evd )
-      !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zavt_evd, zavm_evd ) 
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_evd')
